{*******************************************************************************
 Project       : "Space Shooter ..." ?
 Date          : 2007-07-11
 Version       : 1.3
 Compiler Ver. : Delphi 2007
 Author        : Denny Koberling
 E-Mail        : JasonVoorhees2k@arcor.de
 Copyright     : Copyright (c) 2007 Denny Koberling
*******************************************************************************}

unit UAnimSprite;

interface

uses Windows, Graphics, SysUtils, Math, UAnimBmp, USprite, UTimer, UType;

type
  TAnimSprite = class(TSprite)
  private
    fAnimTimer    : TTimer;
    fAnimLoop     : Boolean;
    fAnimNr       : Byte;
    fAnimDefaultNr: Byte;
    fFrameNr      : Byte;
    procedure SetAnimNr(aAnimNr: Byte);
  protected
    property AnimLoop: Boolean read fAnimLoop write fAnimLoop;
  public
    procedure Move(aMoveCount: Single; aKeys: TKeys; aMouse: TMouse); override;
    procedure Draw(aFrame: TBitmap); override;
    property AnimNr: Byte read fAnimNr write SetAnimNr;
    property AnimDefaultNr: Byte read fAnimDefaultNr write fAnimDefaultNr;
    property FrameNr: Byte read fFrameNr write fFrameNr;
  end;

implementation

{ TSprite }

procedure TAnimSprite.Move(aMoveCount: Single; aKeys: TKeys; aMouse: TMouse);
begin
  if fAnimTimer.Fire(aMoveCount) then begin
    Inc(fFrameNr);
    if fFrameNr=AnimBmp.FrameCount[fAnimNr] then
      if not fAnimLoop then
        Dead
      else begin
        fAnimNr:=fAnimDefaultNr;
        fFrameNr:=0;
        fAnimTimer.Reset(1000 div AnimBmp.FPS[0]);
      end;
  end;
end;

procedure TAnimSprite.Draw(aFrame: TBitmap);
begin
  DrawAlphaSprite(aFrame, Round(X), Round(Y));
end;

procedure TAnimSprite.SetAnimNr(aAnimNr: Byte);
begin
  fAnimNr:=aAnimNr;
  fFrameNr:=0;
  fAnimTimer.Reset(1000 div AnimBmp.FPS[fAnimNr]);
end;

end.
