{*******************************************************************************
 Project       : "Space Shooter ..." ?
 Date          : 2007-06-30
 Version       : 1.3
 Compiler Ver. : Delphi 2007
 Author        : Denny Koberling
 E-Mail        : JasonVoorhees2k@arcor.de
 Copyright     : Copyright (c) 2007 Denny Koberling
*******************************************************************************}

unit uCounter;

interface

uses Windows;

type
  TCounter=class
  private
    fStart: Int64;
  public
    constructor Create;
    procedure Start;
    function Stop: Double;
    function Elapsed: Double;
  end;

implementation

var
  fCPUFrequency: Int64;

constructor TCounter.Create;
begin
  inherited Create;
  Start;
end;

function TCounter.Elapsed: Double;
var
  Stop1: Int64;
begin
  QueryPerformanceCounter(Stop1);
  Result:=(Stop1-fStart)*1000/fCPUFrequency;
end;

procedure TCounter.Start;
begin
  QueryPerformanceCounter(fStart);
end;

function TCounter.Stop: Double;
var
  Stop1: Int64;
begin
  QueryPerformanceCounter(Stop1);
  Result:=(Stop1-fStart)*1000/fCPUFrequency;
  Start;
end;

initialization
  QueryPerformanceFrequency(fCPUFrequency);

end.
