{*******************************************************************************
 Project       : "Space Shooter ..." ?
 Date          : 2007-07-11
 Version       : 1.3
 Compiler Ver. : Delphi 2007
 Author        : Denny Koberling
 E-Mail        : JasonVoorhees2k@arcor.de
 Copyright     : Copyright (c) 2007 Denny Koberling
*******************************************************************************}

unit UEffect;

interface

uses Graphics, Math, UTimer, USprite, UAnimBmp, UType;

type
  TEffect = class(TSprite);

  TBang = class(TEffect)
  public
    constructor Create(aParent: TSprite; aX, aY: Single);
    procedure Draw(aFrame: TBitmap); override;
  end;

  TSmallBang = class(TEffect)
  public
    constructor Create(aParent: TSprite; aX, aY: Single);
    procedure Draw(aFrame: TBitmap); override;
  end;

implementation

{ TBang }

constructor TBang.Create(aParent: TSprite; aX, aY: Single);
begin
  inherited Create(aParent, 'Bang', 3, aX, aY);
  AnimLoop:=False;
end;

procedure TBang.Draw(aFrame: TBitmap);
begin
  DrawAlphaSprite(aFrame, Round(X)-AnimBmp.Width div 2, Round(Y)-AnimBmp.Height div 2);
end;

{ TSmallBang }

constructor TSmallBang.Create(aParent: TSprite; aX, aY: Single);
begin
  inherited Create(aParent, 'Small_Bang', 3, aX, aY);
  AnimLoop:=False;
end;

procedure TSmallBang.Draw(aFrame: TBitmap);
begin
  DrawAlphaSprite(aFrame, Round(X)-AnimBmp.Width div 2, Round(Y)-AnimBmp.Height div 2);
end;

end.
